#pragma once

#include <sfml/Graphics.hpp>
#include <memory>
#include <stdexcept>

namespace cig {
class RenderCall {
  std::shared_ptr<sf::Drawable> drawable;
  sf::RenderStates states;

public:
  explicit RenderCall(const sf::RenderStates &rstates, sf::Drawable *ptr) : drawable(ptr), states(rstates) {
	if (!drawable) {
	  throw std::runtime_error("RenderCall::RenderCall(): Drawable is null");
	}
  }

  void draw(sf::RenderTarget &target, const sf::RenderStates &rstates) const {
	target.draw(*drawable, rstates);
  }
};
}