
#define __LIST_FUNC_DEFINE__(rtt)                                    \
  template <typename T, size_t growth_scalar, size_t growth_summand> \
  rtt List<T, growth_scalar, growth_summand>


namespace cig
{
	__LIST_FUNC_DEFINE__(void)::reserve(const size_t capacity)
	{
		if (!m_Data)
		{
			m_Data = std::unique_ptr<T>(static_cast<T*>(calloc(capacity, sizeof(T))));
			m_Capacity = capacity;
			return;
		}
		std::unique_ptr<T> newData(static_cast<T*>(calloc(capacity, sizeof(T))));
		std::copy(m_Data.get(), m_Data.get() + m_Size, newData.get());
		m_Data = std::move(newData);
		m_Capacity = capacity;
	}
}
